Bug 1403314 - Review Request: python-publicsuffix - Get a public suffix for a domain name using the Public Suffix List.
Summary: Review Request: python-publicsuffix - Get a public suffix for a domain name u...
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Merlin Mathesius
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: 1409935
TreeView+ depends on / blocked
 
Reported: 2016-12-09 15:40 UTC by Stephen Gallagher
Modified: 2017-01-26 00:19 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2017-01-16 19:50:49 UTC
mmathesi: fedora-review+


Attachments (Terms of Use)

Description Stephen Gallagher 2016-12-09 15:40:35 UTC
Spec URL: https://sgallagh.fedorapeople.org/packagereview/python-publicsuffix/python-publicsuffix.spec
SRPM URL: https://sgallagh.fedorapeople.org/packagereview/python-publicsuffix/python-publicsuffix-1.1.0-0.fc25.6.src.rpm

Description:
his module allows you to get the public suffix of a domain name using the Public Suffix List from http://publicsuffix.org

A public suffix is one under which Internet users can directly register names. Some examples of public suffixes are .com, .co.uk and pvt.k12.wy.us. Accurately knowing the public suffix of a domain is useful when handling web browser cookies, highlighting the most important part of a domain name in a user interface or sorting URLs by web site.

It’s up the user to provide this module with an appropriate version of the Public Suffix List. A convenience function is provided that downloads the most recent version available on http://publicsuffix.org

Fedora Account System Username: sgallagh

COPR build: https://copr.fedorainfracloud.org/coprs/sgallagh/python-publicsuffix/build/486522/

Comment 1 Merlin Mathesius 2017-01-04 23:37:23 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated

===== Questions =====

* Why no python3 version of this package? The upstream source appears to be
  compatible.

* Is PyPI the appropriate upstream source, rather than a git or other repo?

* The hashs in the Source URL are not very pretty. Should the URL be something like
  https://files.pythonhosted.org/packages/source/e/publicsuffix/publicsuffix-1.1.0.tar.gz
  as recommended by
  https://fedoraproject.org/wiki/Packaging:SourceURL?rd=Packaging/SourceURL#Python_Packages_.28pypi.29 ?
  Unfortunately, that URL format doesn’t seem to work, but
  https://pypi.io/packages/source/p/publicsuffix/publicsuffix-1.1.0.tar.gz
  does.

* Requires: publicsuffix-list? Why not just Recommends, since the list can
  come from another source? The module even provides a method for retrieving
  the most current list from publicsuffix.org.

* The source tarball includes bundled egg-info. Should that be removed
  by adding “rm -rf %{srcname}.egg-info” after %autosetup?

* What is the reasoning for the .6 suffix on the Release: 0%{?dist}.6 ?

===== Issues =====

* %changelog initial entry needs to include a version-revision tag.

* License: field says MIT, but public_suffix_list.dat is MPLv2.0 and is
  included in the source tarball and installed to %{python2_sitelib}/publicsuffix/public_suffix_list.dat
  when not replaced by a symlink for non-Fedora builds in the %install section.

* subpackage corresponding to current python runtime must supply Provides: python-publicsuffix

===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[!]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "MIT/X11 (BSD like)", "Unknown or generated", "*No copyright*
     MPL (v2.0)". 12 files have unknown license. Detailed output of
     licensecheck in /home/merlinm/package-review/BZ1403314-python-
     publicsuffix/review-python-publicsuffix/licensecheck.txt
[x]: Package contains no bundled libraries without FPC exception.
[!]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[?]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 4 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[-]: A package which is used by another package via an egg interface should
     provide egg info.
[!]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[?]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[-]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: python2-publicsuffix-1.1.0-0.fc25.6.noarch.rpm
          python-publicsuffix-1.1.0-0.fc25.6.src.rpm
python2-publicsuffix.noarch: W: summary-ended-with-dot C Get a public suffix for a domain name using the Public Suffix List.
python2-publicsuffix.noarch: W: spelling-error %description -l en_US uk -> UK, u, k
python2-publicsuffix.noarch: W: spelling-error %description -l en_US wy -> WY, wt, w
python2-publicsuffix.noarch: E: description-line-too-long C This module allows you to get the public suffix of a domain name using the Public Suffix List from http://publicsuffix.org
python2-publicsuffix.noarch: E: description-line-too-long C A public suffix is one under which Internet users can directly register names. Some examples of public suffixes are .com, .co.uk and pvt.k12.wy.us. Accurately knowing the public suffix of a domain is useful when handling web browser cookies, highlighting the most important part of a domain name in a user interface or sorting URLs by web site.
python2-publicsuffix.noarch: E: description-line-too-long C It’s up the user to provide this module with an appropriate version of the Public Suffix List. A convenience function is provided that downloads the most recent version available on http://publicsuffix.org
python2-publicsuffix.noarch: W: no-version-in-last-changelog
python2-publicsuffix.noarch: W: dangling-symlink /usr/lib/python2.7/site-packages/publicsuffix/public_suffix_list.dat /usr/share/publicsuffix/public_suffix_list.dat
python-publicsuffix.src: W: summary-ended-with-dot C Get a public suffix for a domain name using the Public Suffix List.
python-publicsuffix.src: W: spelling-error %description -l en_US uk -> UK, u, k
python-publicsuffix.src: W: spelling-error %description -l en_US wy -> WY, wt, w
python-publicsuffix.src: E: description-line-too-long C This module allows you to get the public suffix of a domain name using the Public Suffix List from http://publicsuffix.org
python-publicsuffix.src: E: description-line-too-long C A public suffix is one under which Internet users can directly register names. Some examples of public suffixes are .com, .co.uk and pvt.k12.wy.us. Accurately knowing the public suffix of a domain is useful when handling web browser cookies, highlighting the most important part of a domain name in a user interface or sorting URLs by web site.
python-publicsuffix.src: E: description-line-too-long C It’s up the user to provide this module with an appropriate version of the Public Suffix List. A convenience function is provided that downloads the most recent version available on http://publicsuffix.org
python-publicsuffix.src: W: no-version-in-last-changelog
2 packages and 0 specfiles checked; 6 errors, 9 warnings.




Rpmlint (installed packages)
----------------------------
python2-publicsuffix.noarch: W: summary-ended-with-dot C Get a public suffix for a domain name using the Public Suffix List.
python2-publicsuffix.noarch: W: spelling-error %description -l en_US uk -> UK, u, k
python2-publicsuffix.noarch: W: spelling-error %description -l en_US wy -> WY, wt, w
python2-publicsuffix.noarch: E: description-line-too-long C This module allows you to get the public suffix of a domain name using the Public Suffix List from http://publicsuffix.org
python2-publicsuffix.noarch: E: description-line-too-long C A public suffix is one under which Internet users can directly register names. Some examples of public suffixes are .com, .co.uk and pvt.k12.wy.us. Accurately knowing the public suffix of a domain is useful when handling web browser cookies, highlighting the most important part of a domain name in a user interface or sorting URLs by web site.
python2-publicsuffix.noarch: E: description-line-too-long C It’s up the user to provide this module with an appropriate version of the Public Suffix List. A convenience function is provided that downloads the most recent version available on http://publicsuffix.org
python2-publicsuffix.noarch: W: no-version-in-last-changelog
python2-publicsuffix.noarch: W: dangling-symlink /usr/lib/python2.7/site-packages/publicsuffix/public_suffix_list.dat /usr/share/publicsuffix/public_suffix_list.dat
1 packages and 0 specfiles checked; 3 errors, 5 warnings.



Requires
--------
python2-publicsuffix (rpmlib, GLIBC filtered):
    python(abi)



Provides
--------
python2-publicsuffix:
    python2-publicsuffix
    python2.7dist(publicsuffix)
    python2dist(publicsuffix)



Source checksums
----------------
https://pypi.python.org/packages/76/8e/2be900ba8397bafe88c9d17fab456faddab7af22d7105df18699d3dd97de/publicsuffix-1.1.0.tar.gz :
  CHECKSUM(SHA256) this package     : ae77593d269e1e5131723259cc1142c25690c20c59f2e98f67e227228028bda9
  CHECKSUM(SHA256) upstream package : ae77593d269e1e5131723259cc1142c25690c20c59f2e98f67e227228028bda9


Generated by fedora-review 0.6.1 (f03e4e7) last change: 2016-05-02
Command line :/usr/bin/fedora-review -n python-publicsuffix
Buildroot used: fedora-25-x86_64
Active plugins: Python, Generic, Shell-api
Disabled plugins: Java, C/C++, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6

Comment 2 Stephen Gallagher 2017-01-05 14:54:31 UTC
(In reply to Merlin Mathesius from comment #1)
> Package Review
> ==============
> 
> Legend:
> [x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
> 
> ===== Questions =====
> 
> * Why no python3 version of this package? The upstream source appears to be
>   compatible.
>

Python 3 was failing to build, so I didn't bother investigating it. Today I took another look with some help from Igor Gnatenko and realized that it supports Python 3, but there was a bug that I could work around by setting the locale explicitly. The next version will support Python 3.

> * Is PyPI the appropriate upstream source, rather than a git or other repo?
> 

Yes, the upstream maintainer doesn't provide any other website for it. That page includes a link to the git repo.

> * The hashs in the Source URL are not very pretty. Should the URL be
> something like
>  
> https://files.pythonhosted.org/packages/source/e/publicsuffix/publicsuffix-1.
> 1.0.tar.gz
>   as recommended by
>  
> https://fedoraproject.org/wiki/Packaging:SourceURL?rd=Packaging/
> SourceURL#Python_Packages_.28pypi.29 ?
>   Unfortunately, that URL format doesn’t seem to work, but
>   https://pypi.io/packages/source/p/publicsuffix/publicsuffix-1.1.0.tar.gz
>   does.

Thanks, I was just using the URL format I got from the download page. This is much cleaner.

> 
> * Requires: publicsuffix-list? Why not just Recommends, since the list can
>   come from another source? The module even provides a method for retrieving
>   the most current list from publicsuffix.org.
> 

Well, first of all it's tiny (the entire package contains a single text file). The reason for it is that if the user is running in a restricted network where they can't retrieve the updated file, we want to ensure they at least have the latest version provided by RPM.

> * The source tarball includes bundled egg-info. Should that be removed
>   by adding “rm -rf %{srcname}.egg-info” after %autosetup?
> 

Yes, that was an oversight. I thought I had done that...

> * What is the reasoning for the .6 suffix on the Release: 0%{?dist}.6 ?
> 

Well, I did it wrong, it should have been 0.6%{?dist}, but it's just a personal convention. I always reserve 0.x for pre-release work while I'm developing. I bump to release 1 when it's expected to go into a release. The .6 was the sixth discrete version of the RPM I had come up with.


> ===== Issues =====
> 
> * %changelog initial entry needs to include a version-revision tag.
> 

Thanks, fixed.

> * License: field says MIT, but public_suffix_list.dat is MPLv2.0 and is
>   included in the source tarball and installed to
> %{python2_sitelib}/publicsuffix/public_suffix_list.dat
>   when not replaced by a symlink for non-Fedora builds in the %install
> section.

You are correct. I changed the License: field to read "MIT and MPLv2.0"


> 
> * subpackage corresponding to current python runtime must supply Provides:
> python-publicsuffix
> 

Fixed.



Spec: https://sgallagh.fedorapeople.org/packagereview/python-publicsuffix/python-publicsuffix.spec

SRPM: https://sgallagh.fedorapeople.org/packagereview/python-publicsuffix/python-publicsuffix-1.1.0-0.7.fc25.src.rpm

COPR: https://copr.fedorainfracloud.org/coprs/sgallagh/python-publicsuffix/build/495902/

Comment 3 Merlin Mathesius 2017-01-05 20:04:21 UTC
Thank you for addressing my questions and concerns.

I verified the updated package functions as described.

I now have a few additional questions/concerns:

* Is the intent that /usr/lib/python*/site-packages/publicsuffix/public_suffix_list.dat be a symlink to /usr/share/publicsuffix/public_suffix_list.dat, or a regular file copy of public_suffix_list.dat picked up from the publicsuffix-list package at RPM build time? It was a link in the previous version of this package, now it's a regular file.

* The %changelog version-revision tag is now 1.1.0-1, but based on the Version and Release, it should be 1.1.0-0.7. I presume this is anticipation of bumping the Release to 1 upon actual release?

* I just noticed the warning that rpmlint doesn't like the Summary: to end with a period. It's just a warning.

Comment 4 Merlin Mathesius 2017-01-05 20:07:47 UTC
One more thing:

* If the intent is to still have a Requires for publicsuffix-list, it needs to be specified in the subpackages--not the main package.

Comment 5 Stephen Gallagher 2017-01-05 20:16:25 UTC
(In reply to Merlin Mathesius from comment #3)
> Thank you for addressing my questions and concerns.
> 
> I verified the updated package functions as described.
> 
> I now have a few additional questions/concerns:
> 
> * Is the intent that
> /usr/lib/python*/site-packages/publicsuffix/public_suffix_list.dat be a
> symlink to /usr/share/publicsuffix/public_suffix_list.dat, or a regular file
> copy of public_suffix_list.dat picked up from the publicsuffix-list package
> at RPM build time? It was a link in the previous version of this package,
> now it's a regular file.
> 

It was supposed to be a link. I guess moving that change into the %prep phase was the wrong approach. I will correct it.

> * The %changelog version-revision tag is now 1.1.0-1, but based on the
> Version and Release, it should be 1.1.0-0.7. I presume this is anticipation
> of bumping the Release to 1 upon actual release?
> 

Yes, that's purely cosmetic.

> * I just noticed the warning that rpmlint doesn't like the Summary: to end
> with a period. It's just a warning.

I'm choosing to ignore that completely.


> One more thing:
> 
> * If the intent is to still have a Requires for publicsuffix-list, it needs
> to be specified in the subpackages--not the main package.

Whoops! You are exactly right.


Spec: https://sgallagh.fedorapeople.org/packagereview/python-publicsuffix/python-publicsuffix.spec

SRPM: https://sgallagh.fedorapeople.org/packagereview/python-publicsuffix/python-publicsuffix-1.1.0-0.8.fc25.src.rpm

COPR: https://copr.fedorainfracloud.org/coprs/sgallagh/python-publicsuffix/build/496019/

Comment 7 Merlin Mathesius 2017-01-05 22:17:05 UTC
Looks good. I approve.

Comment 8 Gwyn Ciesla 2017-01-06 13:14:21 UTC
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/rpms/python-publicsuffix

Comment 9 Fedora Update System 2017-01-06 14:07:36 UTC
python-publicsuffix-1.1.0-1.el6 has been submitted as an update to Fedora EPEL 6. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2017-cbf78d49bf

Comment 10 Fedora Update System 2017-01-06 14:07:43 UTC
python-publicsuffix-1.1.0-1.el7 has been submitted as an update to Fedora EPEL 7. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2017-eaf5d2adb2

Comment 11 Fedora Update System 2017-01-06 14:07:48 UTC
python-publicsuffix-1.1.0-1.fc25 has been submitted as an update to Fedora 25. https://bodhi.fedoraproject.org/updates/FEDORA-2017-7efe82c2ef

Comment 12 Fedora Update System 2017-01-06 14:07:53 UTC
python-publicsuffix-1.1.0-1.fc24 has been submitted as an update to Fedora 24. https://bodhi.fedoraproject.org/updates/FEDORA-2017-1da6e35ee4

Comment 13 Fedora Update System 2017-01-06 16:44:25 UTC
python-publicsuffix-1.1.0-1.el7 has been submitted as an update to Fedora EPEL 7. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2017-eaf5d2adb2

Comment 14 Fedora Update System 2017-01-06 23:21:27 UTC
python-publicsuffix-1.1.0-1.fc25 has been pushed to the Fedora 25 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-7efe82c2ef

Comment 15 Fedora Update System 2017-01-07 00:48:36 UTC
python-publicsuffix-1.1.0-1.el7 has been pushed to the Fedora EPEL 7 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2017-eaf5d2adb2

Comment 16 Fedora Update System 2017-01-07 00:49:31 UTC
python-publicsuffix-1.1.0-1.el6 has been pushed to the Fedora EPEL 6 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2017-cbf78d49bf

Comment 17 Fedora Update System 2017-01-07 01:19:10 UTC
python-publicsuffix-1.1.0-1.fc24 has been pushed to the Fedora 24 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-1da6e35ee4

Comment 18 Fedora Update System 2017-01-16 19:50:49 UTC
python-publicsuffix-1.1.0-1.fc25 has been pushed to the Fedora 25 stable repository. If problems still persist, please make note of it in this bug report.

Comment 19 Fedora Update System 2017-01-16 20:49:40 UTC
python-publicsuffix-1.1.0-1.fc24 has been pushed to the Fedora 24 stable repository. If problems still persist, please make note of it in this bug report.

Comment 20 Fedora Update System 2017-01-26 00:17:59 UTC
python-publicsuffix-1.1.0-1.el6 has been pushed to the Fedora EPEL 6 stable repository. If problems still persist, please make note of it in this bug report.

Comment 21 Fedora Update System 2017-01-26 00:19:12 UTC
python-publicsuffix-1.1.0-1.el7 has been pushed to the Fedora EPEL 7 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.